<template>
  <div>
    <v-dialog v-model="dialog" persistent scrollable width="500">
      <v-btn flat slot="activator">Create Timeslots</v-btn>

      <v-card>
        <v-card-title class="headline pb-0">Create Timeslots</v-card-title>
        <v-stepper v-model="progress" class="elevation-0">
          <v-stepper-header>
            <v-stepper-step step="1" :complete="progress > 0">Date</v-stepper-step>
            <v-divider></v-divider>
            <v-stepper-step step="2" :complete="progress > 1">Time</v-stepper-step>
            <v-divider></v-divider>
            <v-stepper-step step="3" :complete="progress > 2">Configure</v-stepper-step>
          </v-stepper-header>
          <v-stepper-content step="1">
            <v-card-text>
              <!-- Select Date -->
              <v-date-picker v-model="data.selectedDate"></v-date-picker>
            </v-card-text>
          </v-stepper-content>
          <v-stepper-content step="2">
            <v-card-text class="pa-4">
              <!-- Select Duration, Start Time, and End Time -->
              <!-- <v-slider class="mb-2" label="Duration" v-model="data.duration" max="2" thumb-label></v-slider> -->
              <v-layout row>
                <v-flex sm4 class="pt-4">
                  <span class="grey--text">Duration</span>
                </v-flex>
                <v-flex sm8>
                  <v-radio-group v-model="data.duration" row>
                    <v-radio label="1 hour" value="1"></v-radio>
                    <v-radio label="2 hours" value="2"></v-radio>
                  </v-radio-group>
                </v-flex>
              </v-layout>
              <v-menu :close-on-content-click="false" lazy full-width max-width="290" :nudge-left="80">
                <v-text-field slot="activator" label="Start Time" v-model="data.startTime" readonly></v-text-field>
                <v-time-picker v-model="data.startTime" :allowed-minutes="value => { return value % 30 === 0 }">
                  <template scope="{save, cancel}">
                    <v-divider></v-divider>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn flat @click="cancel">Cancel</v-btn>
                      <v-btn flat primary @click="save">Save</v-btn>
                    </v-card-actions>
                  </template>
                </v-time-picker>
              </v-menu>
              <v-menu :close-on-content-click="false" lazy full-width max-width="290" :nudge-left="80">
                <v-text-field slot="activator" label="End Time" v-model="data.endTime" readonly></v-text-field>
                <v-time-picker v-model="data.endTime" :allowed-minutes="value => { return value % 30 === 0 }">
                  <template scope="{save, cancel}">
                    <v-divider></v-divider>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn flat @click="cancel">Cancel</v-btn>
                      <v-btn flat primary @click="save">Save</v-btn>
                    </v-card-actions>
                  </template>
                </v-time-picker>
              </v-menu>
            </v-card-text>
          </v-stepper-content>
          <v-stepper-content step="3">
            <v-card-text>
              <template v-for="timeSlot in timeSlots">
                <v-layout row>
                  <v-flex sm4>
                    <div class="mt-4">{{$moment.unix(timeSlot.startTime).format('h:mma')}} - {{$moment.unix(timeSlot.endTime).format('h:mma')}}</div>
                  </v-flex>
                  <v-flex sm8><v-text-field label="Price" v-model="timeSlot['price']"></v-text-field></v-flex>
                </v-layout>
              </template>
              <v-divider></v-divider>
              <v-layout row>
                <v-flex sm4>
                  <v-checkbox label="Assign same price to all" v-model="samePrice"></v-checkbox>
                </v-flex>
                <v-flex sm8>
                  <v-text-field label="Price" v-model="allPrice"></v-text-field>
                </v-flex>
              </v-layout>
            </v-card-text>
          </v-stepper-content>
        </v-stepper>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn flat @click="prev">{{progress > 1 ? 'Previous' : 'Cancel'}}</v-btn>
          <v-btn primary flat @click="next">{{progress < 3 ? 'Next' : 'Save'}}</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-snackbar v-model="toast.visibility" bottom class="mb-4">
      {{toast['message']}}
      <v-btn flat primary @click="toast.visibility = false">Close</v-btn>
    </v-snackbar>
  </div>
</template>
<script>
  import config from '../../config'
  export default {
    name: 'time-slot',
    data () {
      return {
        dialog: false,
        toast: {
          visibility: false
        },
        progress: 1,
        data: {
          selectedDate: this.$moment().format('YYYY-MM-DD'),
          duration: null,
          startTime: null,
          endTime: null
        },
        samePrice: false,
        allPrice: null
      }
    },
    watch: {
      allPrice (to, from) {
        if (this.samePrice) {
          this.timeSlots.forEach(timeSlot => {
            timeSlot.price = this.allPrice
          })
        }
      }
    },
    computed: {
      timeSlots () {
        let startTime = this.$moment(this.data.startTime, 'h:mma')
        let endTime = this.$moment(this.data.endTime, 'h:mma')
        let slots = []

        let addSlot = () => {
          let newSlot = {
            startTime: startTime.unix(),
            endTime: startTime.add(this.data.duration, 'hours').unix(),
            duration: this.data.duration
          }

          if (newSlot.endTime <= endTime.unix()) {
            slots.push(newSlot)
            addSlot()
          }
        }

        addSlot()
        return slots
      }
    },
    methods: {
      next () {
        if (this.progress < 3) {
          this.progress++
        } else this.save()
      },
      prev () {
        if (this.progress > 1) {
          this.progress--
        } else this.dialog = false
      },
      save () {
        let queue = []
        this.timeSlots.forEach(timeSlot => {
          let startTime = this.$moment(`${this.data.selectedDate} ${this.$moment.unix(timeSlot.startTime).format('h:mma')}`, 'YYYY-MM-DD h:mma').unix()
          let endTime = this.$moment(`${this.data.selectedDate} ${this.$moment.unix(timeSlot.endTime).format('h:mma')}`, 'YYYY-MM-DD h:mma').unix()
          let data = {
            court_id: config.courtId, // this should be dynamic
            created_at: this.$moment().unix() * 1000,
            duration: Number(timeSlot.duration),
            endTime: endTime * 1000,
            startTime: startTime * 1000,
            price: timeSlot.price,
            payment_status: 'pending'
          }

          queue.push(this.$database.ref('games').push(data))
          // console.log(this.$moment.unix(Math.round(data.startTime / 1000)).format('LLL'))
          // console.log(this.$moment.unix(Math.round(data.endTime / 1000)).format('LLL'))
        })

        Promise.all(queue).then(resp => {
          this.dialog = false
          this.toast.message = 'Timeslots has been successfully created.'
          this.toast.visibility = true
        })
      }
    }
  }
</script>

<style scoped>
  .stepper__content { padding: 0; }
  .card__text { height: 400px; }
  .picker { margin: 0 auto; }
</style>
